#include <stdio.h>
//#include "sis1100_var.h"
#include <sys/types.h>
#include "sis3100_vme_calls.h"
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdlib.h>


#define SIS_DEVICE "/dev/sis1100_00remote"



int main(int argc, char **argv){
	if (argc<2){
		printf("Usage %s vmeRegister mode\n",argv[0]);
		printf("Modes:\n\t2\tA24D16\n\t4\tA24D32\n\t6\tA32D16\n\t8\tA32D32\n");
		return 0;
	}

	
	unsigned int addr=strtoul(argv[1],0,16);
	unsigned int data=0;
	int mode=atoi(argv[2]);
	u_int16_t data16;
	u_int32_t data32;
	int rc=0;

	int	fd = open( SIS_DEVICE, O_RDWR, 0);
	if (fd<0){
		printf("Could not open device: %s\n",SIS_DEVICE);
		return 0;
	}

	switch (mode){
		case 2:
			rc=vme_A24D16_read(fd, addr, &data16 ) ;
			data=(unsigned int)data16;
			break;
		case 4:
			rc=vme_A24D32_read(fd, addr, &data32 ) ;
			data=(unsigned int)data32;
			break;
		case 6:
			rc=vme_A32D16_read(fd, addr, &data16 ) ;
			data=(unsigned int)data16;

			break;
		case 8:
			rc=vme_A32D32_read(fd, addr, &data32 ) ;
			data=(unsigned int)data32;
			break;
	}
        printf("Read from addr=%x data=%x status=%x\n",addr,data,rc);
	close(fd);
	return 0;
}

