#include <stdio.h>
//#include "sis1100_var.h"
#include <sys/types.h>
#include "sis3100_vme_calls.h"
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdlib.h>


#define SIS_DEVICE "/dev/sis1100_00remote"



int main(int argc, char **argv){
	if (argc<3){
		printf("Usage %s vmeRegister data mode\n",argv[0]);
		printf("Modes:\n\t2\tA24D16\n\t4\tA24D32\n\t6\tA32D16\n\t8\tA32D32\n");
		return 0;
	}

	
	unsigned int addr=strtoul(argv[1],0,16);
	unsigned int data=strtoul(argv[2],0,16);
	int mode=atoi(argv[3]);
	unsigned short data16;
	int rc=0;

	int	fd = open( SIS_DEVICE, O_RDWR, 0);
	if (fd<0){
		printf("Could not open device: %s\n",SIS_DEVICE);
		return 0;
	}

	switch (mode){
		case 2:
			data16=(unsigned short)data;
			rc=vme_A24D16_write(fd, addr, data16 ) ;
			break;
		case 4:
			rc=vme_A24D32_write(fd, addr, data ) ;
			break;
		case 6:
			data16=(unsigned short)data;
			rc=vme_A32D16_write(fd, addr, data16 ) ;
			break;
		case 8:
			rc=vme_A32D32_write(fd, addr, data ) ;
			break;
	}
        printf("Written to addr=%x data=%x status=%x\n",addr,data,rc);
	close(fd);
	return 0;
}

